
/* List10-16-1@ȈnetcatR}h */

#include <sys/types.h>     /* socket̂߂ɕKvȃwb_t@C */
#include <sys/socket.h>    /* socket̂߂ɕKvȃwb_t@C */
#include <netdb.h>         /* getaddrinfo()̂߂ɕKvȃwb_t@C */
#include <sys/select.h>    /* select̂߂ɕKvȃwb_t@C */
#include <unistd.h>        /* readwritê߂ɕKvȃwb_t@C */
#include <stdio.h>         /* perror()̂߂ɕKvȃwb_t@C */
#include <string.h>        /* memset()̂߂ɕKvȃwb_t@C */

int
main(int argc, char **argv)
{
  int sock_fd;             /* \Pbg̃t@CLqq */
  struct addrinfo hints, *res;   /* getaddrinfo()Ŏgpaddrinfo\ */
  int err;                 /* getaddrinfo()̃G[R[h */
  fd_set readfds;          /* ǂݏoĎpt@CLqq̏W */
  ssize_t n;               /* ǂݍ݃oCg󂯎ϐ */
  char buf[4096];          /* f[^o͗pobt@ */

  if (argc != 3) {         /* R}ȟȂꍇ */
    fprintf(stderr, "Usage: %s hostname port\n", argv[0]);
    return 1;              /* Usage:\āA߂l1ňُI */
  }

  memset(&hints, 0, sizeof hints);  /* addrinfo\̂hints0ŃNA */
  hints.ai_family = AF_INET;        /* INEThCw */
  hints.ai_socktype = SOCK_STREAM;  /* TCPw */
                           /* R}h̃zXgƃT[rX */
                           /* IPAhXƃ|[gԍɕϊ */
  if ((err = getaddrinfo(argv[1], argv[2], &hints, &res)) != 0) {
    fprintf(stderr, "%s %s: %s\n", argv[1], argv[2], gai_strerror(err));
    return 1;              /* ϊłȂꍇ̓G[\ĈُI */
  }

                           /* TCP̃\Pbg쐬 */
  if ((sock_fd = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");      /* G[̏ꍇ̓bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
                           /* wIPAhX̎w|[gԍɐڑ */
  if (connect(sock_fd, res->ai_addr, res->ai_addrlen) < 0) {
    perror("connect");     /* G[̏ꍇ̓bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }

  for (;;) {               /* ʐM̂߂̃[v */
    FD_ZERO(&readfds);          /* t@CLqqW */
    FD_SET(0, &readfds);        /* W͂̃t@CLqqZbg */
    FD_SET(sock_fd, &readfds);  /* \Pbg̃t@CLqqZbg */

                           /* W͂ƃ\Pbgւ̃f[^𓯎ɊĎ */
    if (select(sock_fd + 1, &readfds, NULL, NULL, NULL) < 0) {
      perror("select");    /* G[̏ꍇ̓bZ[W\ */
      return 1;            /* ߂l1ňُI */
    }

    if (FD_ISSET(0, &readfds)) {  /* W͂ɓ͂ꍇ */
      if ((n = read(0, buf, sizeof buf)) < 0) {  /* W͂ǂݍ */
        perror("read");    /* G[̏ꍇ̓bZ[W\ */
        return 1;          /* ߂l1ňُI */
      }
      if (n == 0) {        /* W͂EOFɂȂꍇ */
        break;             /* for̃[vI */
      }
      write(sock_fd, buf, n);  /* ǂݍ񂾃f[^\PbgɑM */
    }

    if (FD_ISSET(sock_fd, &readfds)) {  /* \PbgMꍇ */
      if ((n = read(sock_fd, buf, sizeof buf)) < 0) {  /* \Pbgǂݍ */
        perror("read");    /* G[̏ꍇ̓bZ[W\ */
        return 1;          /* ߂l1ňُI */
      }
      if (n == 0) {        /* \PbgEOFɂȂꍇ */
        break;             /* for̃[vI */
      }
      write(1, buf, n);    /* ǂݍ񂾃f[^Wo͂ɏo */
    }
  }

  if (shutdown(sock_fd, SHUT_RDWR) < 0) {  /* \PbgVbg_E */
    perror("shutdown");    /* G[̏ꍇ̓bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
  return 0;                /* ߂l0ŐI */
}


