
/* List3-26-1@ioctl̃TvvO */

#include <sys/ioctl.h>     /* ioctl̂߂ɕKvȃwb_t@C */

#include <sys/types.h>     /* socket̂߂ɕKvȃwb_t@C */
#include <sys/socket.h>    /* socket̂߂ɕKvȃwb_t@C */
#include <net/if.h>        /* struct ifconfȂǂ̂߂ɕKvȃwb_t@C */
#include <netinet/in.h>    /* inet_ntoa()̂߂ɕKvȃwb_t@C */
#include <arpa/inet.h>     /* inet_ntoa()̂߂ɕKvȃwb_t@C */
#include <stdio.h>         /* perror()̂߂ɕKvȃwb_t@C */

#if defined(__sun__) && defined(__svr4__)   /* Solaris̏ꍇ̑Ή */
# include <unistd.h>       /* ioctl̂߂ɕKvȃwb_t@C */
# include <sys/sockio.h>   /* SIOCGIFCONFȂǂ̒` */
#endif

int
main()
{
  struct ifconf ifc;       /* SIOCGIFCONFŎgp\ */
  struct ifreq ifrbuf[16]; /* C^tFCXƂ̏󂯎z */
  struct ifreq *ifrp;      /* ifrbuf[]w|C^ */
  int sfd;                 /* \Pbg̃t@CLqq */
  int adj = 0;             /* FreeBSD̏ꍇifrp̃AhXvZ␳ */

                           /* INEThC\Pbg̃t@CLqq擾 */
  if ((sfd = socket(PF_INET, SOCK_DGRAM, 0)) < 0) {
    perror("socket");      /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }

  ifc.ifc_req = ifrbuf;        /* ifconf\̂̏胁oifrbufZbg */
  ifc.ifc_len = sizeof ifrbuf; /* lifrbuf̃TCYZbg */
  if (ioctl(sfd, SIOCGIFCONF, &ifc) < 0) { /* C^tFCX̍\擾 */
    perror("ioctl(SIOCGIFCONF)");          /* G[̏ꍇ̓bZ[W\ */
    return 1;                              /* ߂l1ňُI */
  }

                           /* lbg[NC^tFCXƂɃ[v */
  for (
    ifrp = ifrbuf;         /* ifrpifrbuf̐擪ɏ */
                           /* ifrbufɓǂݍ߂f[^TCY͈͓̔Ń[v */
    ifrp < (struct ifreq *)&((char *)ifrbuf)[ifc.ifc_len];
    ifrp++                 /* ̃C^tFCXɐi */
  ) {
                           /* FreeBSD̏ꍇ̑Ή */
#if defined(__FreeBSD__) || defined(__NetBSD__) || defined(__OpenBSD__)
                           /* ifrp̃AhXvZ̕␳lvZ */
    adj = ifrp->ifr_addr.sa_len - sizeof (struct sockaddr);
    if (adj < 0) {
      adj = 0;
    }
#endif

                           /* lbg[NC^tFCX\ */
    printf("%s:", ifrp->ifr_name);

                           /* lbg[NC^tFCXIPAhX擾 */
    if (ioctl(sfd, SIOCGIFADDR, ifrp) < 0) {
      putchar('\n');       /* IPAhX蓖ďꍇ͉ŝݏo */
    } else {
                           /* IPAhXhbgt10i\Lɕϊĕ\ */
      printf(" %s\n",
        inet_ntoa(((struct sockaddr_in *)&ifrp->ifr_addr)->sin_addr)
      );
    }
                           /* ifrp̃AhXvZ␳ */
    ifrp = (struct ifreq *)&((char *)ifrp)[adj];
  }                        /* ȏforŃ[v */

  return 0;                /* ߂l0ŐI */
}


