
/* List10-14-1@ȈtimeR}h */

#include <sys/types.h>     /* wait3̂߂ɕKvȃwb_t@C */
#include <sys/time.h>      /* wait3/gettimeofdaŷ߂ɕKvȃwb_t@C */
#include <sys/resource.h>  /* wait3̂߂ɕKvȃwb_t@C */
#include <sys/wait.h>      /* wait3̂߂ɕKvȃwb_t@C */
#include <unistd.h>        /* forkexecvp()̂߂ɕKvȃwb_t@C */
#include <stdio.h>         /* perror()̂߂ɕKvȃwb_t@C */

int
main(int argc, char **argv)
{
  int status;              /* qvZX̏IXe[^X󂯎ϐ */
  pid_t pid;               /* qvZX̃vZXID */
  struct rusage usage;     /* qvZX̃\[X󂯎rusage\ */
  struct timeval tv_start, tv_end;  /* JnƏIL^ */

                           /* R}hȂꍇUsage:\ */
  if (argc <= 1) {
    fprintf(stderr, "Usage: %s command [arg...]\n", argv[0]);
    return 1;              /* ߂l1ňُI */
  }
                           /* ݂̎擾tv_startɕۑĂ */
  if (gettimeofday(&tv_start, NULL) < 0) {
    perror("gettimeofday");  /* G[̏ꍇ̓bZ[W\ */
    return 1;                /* ߂l1ňُI */
  }

                           /* qvZX쐬 */
  if ((pid = fork()) < 0) {
    perror("fork");        /* G[̏ꍇ̓bZ[W\ */
    return 1;              /* ߂l1ňُI */
  } else if (pid == 0) {        /* qvZX̏ꍇ */
    execvp(argv[1], &argv[1]);  /* Ŏw肳ꂽR}hs */
    perror(argv[1]);            /* słȂꍇ̓bZ[W\ */
    _exit(1);                   /* ߂l1ŎqvZXI */
  }
                           /* qvZX̏I҂A\[X擾 */
  if (wait3(&status, 0, &usage) < 0) {
    perror("wait3");       /* G[̏ꍇ̓bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
                           /* qvZXI_ł̎tv_endɎ擾 */
  if (gettimeofday(&tv_end, NULL) < 0) {
    perror("gettimeofday");  /* G[̏ꍇ̓bZ[W\ */
    return 1;                /* ߂l1ňُI */
  }
                           /* tv_endtv_secČo߂ԂvZ */
  tv_end.tv_sec -= tv_start.tv_sec;
  if ((tv_end.tv_usec -= tv_start.tv_usec) < 0) { /* 1b̌J艺菈 */
    tv_end.tv_sec--;             /* J艺̏ꍇAbPʂ1 */
    tv_end.tv_usec += 1000000;   /* }CNbPʂ1000000}CNbZ */
  }
                           /* qvZX̎ԁA[UԁAVXeԂ
                              WG[o͂ɏo */
  fprintf(
    stderr,
    "real   = %ld.%06ld\n"
    "user   = %ld.%06ld\n"
    "system = %ld.%06ld\n",
    tv_end.tv_sec, tv_end.tv_usec,
    usage.ru_utime.tv_sec, usage.ru_utime.tv_usec,
    usage.ru_stime.tv_sec, usage.ru_stime.tv_usec
  );

  if (WIFEXITED(status)) {       /* qvZX̏IXe[^Xꂽꍇ */
    return WEXITSTATUS(status);  /* ̏IXe[^X߂lƂďI */
  }
  return 1;                /* ȊO͖߂l1ňُI */
}

