
/* List8-5-1@socket/bind/listen/accept/connect̃TvvOiT[oj */

#include <sys/types.h>     /* socket̂߂ɕKvȃwb_t@C */
#include <sys/socket.h>    /* socket̂߂ɕKvȃwb_t@C */
#include <netinet/in.h>    /* sockaddr_in\̂̂߂ɕKvȃwb_t@C */

#include <unistd.h>        /* readwritê߂ɕKvȃwb_t@C */
#include <stdio.h>         /* perror()̂߂ɕKvȃwb_t@C */
#include <string.h>        /* memset()̂߂ɕKvȃwb_t@C */
#include <arpa/inet.h>     /* inet_ntoa()̂߂ɕKvȃwb_t@C */

int
main()
{
  int sock_fd, ac_fd;      /* socketacceptp̃t@CLqq */
  struct sockaddr_in sv_addr, cl_addr;   /* pƑp̃\PbgAhX */
  socklen_t cl_len;        /* cl_addr̃TCYi[p */
  int optval;              /* \PbgIvV̒l */
  socklen_t optlen;        /* optval̃TCY */
  ssize_t n;               /* Mf[^̃oCg󂯎ϐ */
  char buf[4096];          /* f[^Mpobt@z */

                           /* TCP\Pbg쐬 */
  if ((sock_fd = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");      /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }

  optval = 1;              /* IvV̒l1i^jɂ */
                           /* SO_REUSEADDRl1ɐݒ肵AhXĎgp */
  if (setsockopt(sock_fd, SOL_SOCKET, SO_REUSEADDR,
      &optval, sizeof optval) < 0) {
    perror("setsockopt");  /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }

  optlen = sizeof optval;  /* optlenoptval̃TCYZbg */
                           /* SO_REUSEADDR̒l擾 */
  if (getsockopt(sock_fd, SOL_SOCKET, SO_REUSEADDR, &optval, &optlen) < 0) {
    perror("getsockopt");  /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
                           /* SO_REUSEADDR̒l\ */
  fprintf(stderr, "SO_REUSEADDR = %d\n", optval);

  memset(&sv_addr, 0, sizeof sv_addr);          /* sv_addr̓e0ɃNA */
  sv_addr.sin_family = AF_INET;                 /* INEThCw */
  sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);  /* IPAhX͔C */
  sv_addr.sin_port = htons(12345);              /* |[gԍ12345 */
                           /* \PbgɃ\PbgAhX蓖Ă */
  if (bind(sock_fd, (struct sockaddr *)&sv_addr, sizeof sv_addr) < 0) {
    perror("bind");        /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
                           /* \Pbglisten */
  if (listen(sock_fd, SOMAXCONN) < 0) {
    perror("listen");      /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }

  cl_len = sizeof cl_addr; /* cl_lencl_addr̃TCYZbg */
                           /* NCAg̐ڑ󂯕t */
  if ((ac_fd = accept(sock_fd, (struct sockaddr *)&cl_addr, &cl_len)) < 0) {
    perror("accept");      /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
                           /* NCAgIPAhXƃ|[gԍ\ */
  fprintf(stderr, "connect from addr = %s, port = %d\n",
    inet_ntoa(cl_addr.sin_addr),
    ntohs(cl_addr.sin_port)
  );
                           /* NCAg̃f[^MȂ烋[v */
  while ((n = read(ac_fd, buf, sizeof buf)) > 0) {
    write(ac_fd, buf, n);  /* Mf[^̂܂܃NCAgɑԂ */
    write(1, buf, n);      /* Mf[^Wo͂ɏo */
  }
  if (n < 0) {             /* readŃG[ꍇ */
    perror("read");        /* G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
                           /* ʐMՒf */
  if (shutdown(ac_fd, SHUT_RDWR) < 0) {
    perror("shutdown");    /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
  return 0;                /* ߂l0ŐI */
}


