
/* List8-5-2@socket/bind/listen/accept/connect̃TvvOiNCAg */

#include <sys/types.h>     /* socket̂߂ɕKvȃwb_t@C */
#include <sys/socket.h>    /* socket̂߂ɕKvȃwb_t@C */
#include <netinet/in.h>    /* sockaddr_in\̂̂߂ɕKvȃwb_t@C */

#include <unistd.h>        /* readwritê߂ɕKvȃwb_t@C */
#include <stdio.h>         /* perror()̂߂ɕKvȃwb_t@C */
#include <string.h>        /* memset()̂߂ɕKvȃwb_t@C */

int
main()
{
  int sock_fd;             /* \Pbg̃t@CLqq */
  struct sockaddr_in sv_addr;  /* \PbgAhXp\ */
  ssize_t n;               /* Mf[^̃oCg󂯎ϐ */
  char buf[4096];          /* f[^Mpobt@z */

                           /* TCP\Pbg쐬 */
  if ((sock_fd = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");      /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }

  memset(&sv_addr, 0, sizeof sv_addr);          /* sv_addr̓e0ɃNA */
  sv_addr.sin_family = AF_INET;                 /* INEThCw */
  sv_addr.sin_addr.s_addr = htonl(INADDR_LOOPBACK);  /* localhostw */
  sv_addr.sin_port = htons(12345);              /* |[gԍ12345 */
                           /* T[õ\PbgAhXɐڑ */
  if (connect(sock_fd, (struct sockaddr *)&sv_addr, sizeof sv_addr) < 0) {
    perror("connect");     /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }

  write(sock_fd, "Hello\n", 6);  /* T[oɃeXgbZ[W𑗐M */

                           /* T[õf[^M */
  if ((n = read(sock_fd, buf, sizeof buf)) < 0) {
    perror("read");        /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
  write(1, buf, n);        /* Mf[^Wo͂ɏo */

                           /* ʐMՒf */
  if (shutdown(sock_fd, SHUT_RDWR) < 0) {
    perror("shutdown");    /* G[ꍇ̓G[bZ[W\ */
    return 1;              /* ߂l1ňُI */
  }
  return 0;                /* ߂l0ŐI */
}


