
/* List9-2-1@socketcall̃TvvO */

#include <sys/syscall.h>   /* syscall̂߂ɕKvȃwb_t@C */
#include <unistd.h>        /* syscall̂߂ɕKvȃwb_t@C */
#include <linux/net.h>     /* SYS_SOCKET̒`̂߂ɕKvȃwb_t@C */

#include <sys/types.h>     /* socket̂߂ɕKvȃwb_t@C */
#include <sys/socket.h>    /* socket̂߂ɕKvȃwb_t@C */
#include <netinet/in.h>    /* sockaddr_in\̂̂߂ɕKvȃwb_t@C */

#include <stdio.h>         /* perror()̂߂ɕKvȃwb_t@C */
#include <string.h>        /* memset()̂߂ɕKvȃwb_t@C */
#include <arpa/inet.h>     /* inet_ntoa()̂߂ɕKvȃwb_t@C */

int
mysock(int call, ...)      /* socketcallĂяo߂̊֐ */
{
                           /* X^bN̈𗘗psocketcallĂяo */
  return syscall(SYS_socketcall, call, (&call)+1);
}

int
main()
{
  int sock_fd, ac_fd;
  struct sockaddr_in sv_addr, cl_addr;
  socklen_t cl_len;
  int optval;
  socklen_t optlen;
  ssize_t n;
  char buf[4096];

                           /* socketcalloRsocketĂяo */
  if ((sock_fd = mysock(SYS_SOCKET, PF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");
    return 1;
  }

  optval = 1;              /* socketcalloRsetsockoptĂяo */
  if (mysock(SYS_SETSOCKOPT, sock_fd, SOL_SOCKET, SO_REUSEADDR,
      &optval, sizeof optval) < 0) {
    perror("setsockopt");
    return 1;
  }

  optlen = sizeof optval;  /* socketcalloRgetsockoptĂяo */
  if (mysock(SYS_GETSOCKOPT, sock_fd, SOL_SOCKET, SO_REUSEADDR,
      &optval, &optlen) < 0) {
    perror("setsockopt");
    return 1;
  }
  fprintf(stderr, "SO_REUSEADDR = %d\n", optval);

  memset(&sv_addr, 0, sizeof sv_addr);
  sv_addr.sin_family = AF_INET;
  sv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  sv_addr.sin_port = htons(12345);
                           /* socketcalloRbindĂяo */
  if (mysock(SYS_BIND, sock_fd,
                 (struct sockaddr *)&sv_addr, sizeof sv_addr) < 0) {
    perror("bind");
    return 1;
  }
                           /* socketcalloRlistenĂяo */
  if (mysock(SYS_LISTEN, sock_fd, SOMAXCONN) < 0) {
    perror("listen");
    return 1;
  }

  cl_len = sizeof cl_addr; /* socketcalloRacceptĂяo */
  if ((ac_fd = mysock(SYS_ACCEPT, sock_fd,
                          (struct sockaddr *)&cl_addr, &cl_len)) < 0) {
    perror("accept");
    return 1;
  }

  fprintf(stderr, "connect from addr = %s, port = %d\n",
    inet_ntoa(cl_addr.sin_addr),
    ntohs(cl_addr.sin_port)
  );

  while ((n = read(ac_fd, buf, sizeof buf)) > 0) {
    write(ac_fd, buf, n);
    write(1, buf, n);
  }
  if (n < 0) {
    perror("read");
    return 1;
  }
                           /* socketcalloRshutdownĂяo */
  if (mysock(SYS_SHUTDOWN, ac_fd, SHUT_RDWR) < 0) {
    perror("shutdown");
    return 1;
  }
  return 0;
}


